package pxbase;

import java.io.*;
import java.sql.*;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.ext.*;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

import pxbase.BaseArray;
import xml64.Xml64;

public class pxbase_save extends DefaultHandler implements LexicalHandler{
    static int ELEMENT_TYPE = 1;
    static int ATTR_TYPE = 2;
    static int TEXT_TYPE = 3;
    static int DTD_TYPE = 4;
    static int PI_TYPE = 5;
    static int COMMENT_TYPE = 6;
    static int XML_TYPE = 7;
    static int NAME_TYPE = 8;
    
    private Connection con;    // The connection to the database
    private Statement  st;    // Our statement to run queries with
    
    private String table = "";     //@e[u
    private int db;                //f[^x[X
    private int press_flg = 0;
    
    private String text_tmp = "";
    private String enc = "SJIS";
    private int root_flg = 0;
    private int id_tmp = 0;
    private int id_num = 0;
    private int node_level = 1;
    private int nsd_index = 0;  //default̃l[Xy[X̃CfbNX
    private BaseArray level = new BaseArray();
    private BaseArray index = new BaseArray();
    private BaseArray index2 = new BaseArray();
    private BaseArray parent_buff = new BaseArray();
    private BaseArray parent_buff2 = new BaseArray();
	private String docBase = "C:/apache-tomcat-9.0.34/webapps/pxbase/";
    private FileWriter fw;
	public xml64.Xml64 xml64;

	public pxbase_save(String dbname,Connection db_con,String db_table,String doc)
    throws ClassNotFoundException, FileNotFoundException, IOException, SQLException {
		xml64 = new xml64.Xml64(1);
        con = db_con;
        table = db_table;
        if(dbname.equalsIgnoreCase("PostgreSQL"))
            db = 1;
        else if(dbname.equalsIgnoreCase("MySQL"))
            db = 2;
        else
            db = 3;
        st = con.createStatement();
        level.set_int(0,0);
		docBase = doc;
		fw = new FileWriter(docBase+"sample_out.xml");
    
    }
    public ResultSet do_query(String sql,String func) throws Exception{
        ResultSet rs=null;
        String tmp = sql.substring(0,6);
        try{
            if(tmp.equalsIgnoreCase("select")){
                rs = st.executeQuery(sql);
            }else{
                st.executeUpdate(sql);
            }
        }catch(Exception e){
            String error ="\nG[II\n"+func+":do_query: "+sql+"̎sɎs܂\n";
            try{
                 con.rollback();
                 if(db == 2){
                    sql = "unlock tables";
                    st.executeUpdate(sql);
                }
            }catch(Exception e2){
                error += "\nG[II\n"+func+":do_query: rollback ̎sɎs܂\n";
                try{
                    if(db == 2){
                        sql = "unlock tables";
                        st.executeUpdate(sql);
                    }
                }catch(Exception e3){
                    error += "\nG[II\n"+func+":do_query: "+sql+"̎sɎs܂\n";
                    die(error);
                }
                die(error);
            }
            die(error);
        }
        return rs;
    }
    public void begin() throws Exception{
        if(db == 1){
          String sql = "begin";
          do_query(sql,"begin");
        }else if(db == 2){
   	      con.setAutoCommit(false);
        }
                   
    }
    public void commit() throws Exception {
        if(db == 1){
          String sql = "commit";
          do_query(sql,"commit");
        }else if(db == 2){
          con.commit();
        }
    }
    public void lock()  throws Exception{
        if(db == 1){
            String sql = "lock table "+table+" in share row exclusive mode";
            do_query(sql,"lock");
        }else if(db == 2){
            String sql = "lock tables "+table+" write";
            do_query(sql,"lock");
        }
    }
    public void unlock() throws Exception {
        String sql = "unlock tables";
        do_query(sql,"lock");
    }
    public int num_rows(ResultSet rs) throws Exception {
        if(rs != null){
            rs.last();
            int num = rs.getRow();
            rs.beforeFirst();
            return num;
        }else{
            return 0;
        }
    }
    public String result(ResultSet rs,int row,String field) throws Exception{
        rs.absolute(row);
        String data = rs.getString(field);
		data = xml64.text_decode(data,enc);
        return data;
    }
    
    public void make_table(int flg) throws Exception{
        String sql="";
        if(flg == 1){
            sql = "select * from "+table;
            try{
                ResultSet rs = st.executeQuery(sql);
                rs.close();
                sql = "drop table "+table;
                do_query(sql,"make_table");
            }catch(Exception e){
            }
        }
        sql = "create table "+table+" (id integer NOT NULL,type smallint,name text,value text,parent integer,pos integer,ns text,PRIMARY KEY(id))";
        //        system.out.print(sql);
        do_query(sql,"make_table");
    }
    public void file2table(String file,int flg) throws Exception{
		press_flg = flg;
        FileReader fr = new FileReader(file);
        LineNumberReader lr = new LineNumberReader(fr);
        String text = lr.readLine();
        int pos2 = -1;
        int pos3 = -1;
        int pos = text.indexOf("<?xml");
        String xml="";
        if(pos != -1){
            pos2 = text.indexOf("?>");
            if(pos2 != -1){
                xml = text.substring(pos,pos2+2) + "\n";
            }else{
                xml = text;
                while((text = lr.readLine())!= null){
                    pos2 = text.indexOf("?>");
                    if(pos2 != -1){
                        xml = xml + text.substring(0,pos2+2) + "\n";
                        break;
                    }else{
                        xml = xml + text;
                    }
                }
                if(pos2 == -1)
                    die("XML錾ُł\n");
            }
			get_encode(xml);
            String tmp = text.toUpperCase();
            pos2 = tmp.indexOf("<!DOCTYPE");
            pos3 = tmp.indexOf("]>");
        }else
            die("XML錾ُł\n");
        String dtd = "";
        if(pos2 != -1){
            if(pos3 > pos2){
                dtd = text.substring(pos2,pos3+2) + "\n";
            }else{
                dtd = text.substring(pos2)+"\n";
                while((text = lr.readLine()) != null){
                    pos3 = text.indexOf("]>");
                    if(pos3 != -1){
                        dtd = dtd + text.substring(0,pos3+2) + "\n";
                        break;
                    }else{
                        dtd = dtd + text+"\n";
                    }
                }
                if(pos3 == -1)
                    die("DTD̍\ُł\n");
            }
        }else{
            while((text = lr.readLine()) != null){
                String tmp = text.toUpperCase();
                pos2 = tmp.indexOf("<!DOCTYPE");
                if(pos2 == -1)
                    continue;
                pos3 = tmp.indexOf("]>");
                if(pos3 != -1)
                    dtd = text.substring(pos2,pos3+2) + "\n";
                else
                    dtd = text.substring(pos2)+"\n";
                while((text = lr.readLine()) != null){
                    pos3 = text.indexOf("]>");
                    if(pos3 != -1){
                        dtd = dtd + text.substring(0,pos3+2) + "\n";
                        break;
                    }else{
                        dtd = dtd + text+"\n";
                    }
                }
                if(pos3 == -1)
                    die("DTD̍\ُł\n");
                break;
            }
        }
        lr.close();
        //System.out.print("XML:"+xml+"\n");
        id_num++;
        index.set_int(node_level,1);
        parent_buff.set_int(node_level,0);
        xml = addslashes(xml);
		xml = xml64.text_encode(xml,enc);
        String sql = "insert into "+table+" (id,type,value,parent,pos) values("+id_num+","+XML_TYPE+",'"+xml+"',0,1)";
        do_query(sql,"XML");
        
        if(!dtd.equals("")){
            //System.out.print("DTD:"+dtd+"\n");
            id_num++;
            pos = index.get_int(node_level);
            if(pos == 0){
                pos = 1;
            }else{
                pos++;
            }
            index.set_int(node_level,pos);
            dtd = addslashes(dtd);
			dtd = xml64.text_encode(dtd,enc);
            sql = "insert into "+table+" (id,type,value,parent,pos) values("+id_num+","+DTD_TYPE+",'"+dtd+"',0,"+pos+")";
            do_query(sql,"dtd");
        }
        
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try{     // Set up output stream
            //out = new OutputStreamWriter(System.out, "SJIS");
            // Parse the input
            SAXParser saxParser = factory.newSAXParser();
            XMLReader xmlReader = saxParser.getXMLReader();
            xmlReader.setProperty(
            "http://xml.org/sax/properties/lexical-handler",
            this
            );
            //System.out.print("begin\n");
            saxParser.parse( new File(file), this);
        } catch (SAXParseException spe) {
            // Error generated by the parser
            String error ="\n** Parsing error"
            + ", line " + spe.getLineNumber()
            + ", uri " + spe.getSystemId();
            error += "   " + spe.getMessage();
            
            // Use the contained exception, if any
            Exception  x = spe;
            if (spe.getException() != null)
                x = spe.getException();
            error +=  x.getMessage();
            die(error);
        } catch (SAXException sxe) {
            // Error generated by this application
            // (or a parser-initialization error)
            Exception  x = sxe;
            if (sxe.getException() != null)
                x = sxe.getException();
            die(x.getMessage());
            
        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            die(pce.getMessage());
            
        } catch (IOException ioe) {
            // I/O error
            die(ioe.getMessage());
        }
    }
    
    //===========================================================
    // SAX DocumentHandler methods
    //===========================================================
    public void startDocument()
    throws SAXException {
        //System.out.print("StartDocument\n");
    }
    
    public void endDocument()
    throws SAXException {
        //System.out.print("EndDocument\n");
		try{
			fw.close();
		}catch(Exception e){}
    }
    
    public void startElement(String namespaceURI,
    String lName, // local name
    String qName, // qualified name
    Attributes attrs)
    throws SAXException {
        //System.out.print("start elm:"+qName+"\n");
		lName = UnicodeToEuc(lName);
		qName = UnicodeToEuc(qName);
        try{
            if(!text_tmp.equals("")){
                save_textnode(id_tmp,text_tmp);
                text_tmp = "";
            }
            int pos = qName.indexOf(":");
            if(pos != -1){
                namespaceURI = qName.substring(0,pos);
                lName = qName.substring(pos+1);
            }else{
                namespaceURI = new String("");
                lName = qName;
            }
            id_tmp = save_node(id_tmp,lName,attrs,namespaceURI);
        }catch(Exception e){
            throw new SAXException(e);
        }
    }
    
    public void endElement(String namespaceURI,
    String sName, // simple name
    String qName  // qualified name
    )
    throws SAXException {
        //System.out.print("end elm:"+qName+"\n");
        
        if(!text_tmp.equals("")){
            try{
                save_textnode(id_tmp,text_tmp);
            }catch(Exception e){
                throw new SAXException(e);
            }
            text_tmp = "";
        }
        //@̃x̐eZbg
        id_tmp = parent_buff.get_int(node_level);
        node_level--;
    }
    
    public void characters(char buf[], int offset, int len)
    throws SAXException {
        String data = new String(buf,offset,len);
		String tmp = data;
        
        data = data.trim();
        data = replace("<","&lt;",data);
        data = replace(">","&gt;",data);
        text_tmp += data;
        int pos = tmp.indexOf("\n");
        if((pos != -1)&&(!text_tmp.equals(""))){
            text_tmp = text_tmp.trim() + "\n";
        }
    }
    public void comment(char[] ch, int start, int length) throws org.xml.sax.SAXException {
        String text = "<!--" + new String(ch, start, length) + "-->";
        //System.out.print("Comment:"+text+"\n");
        try{
            text = UnicodeToEuc(text);
			save_comment(id_tmp,text);
        }catch(Exception e){
            throw new SAXException(e);
        }
    }
    public void processingInstruction(java.lang.String target,java.lang.String data)
    throws SAXException {
        //@new id̍쐬
        int id = id_num+1;
        id_num++;
        //System.out.print("Pi:"+target+"\n");
        node_level = level.get_int(0) + 1;
        int pos = 1;
        if(!index.isEmpty()){
            pos = index.get_int(node_level) + 1;
        }
        index.set_int(node_level,pos);
		target = UnicodeToEuc(target);
		data = UnicodeToEuc(data);
        target = addslashes(target);
        data = addslashes(data.trim());
		try{
			target = xml64.text_encode(target,enc);
			data = xml64.text_encode(data,enc);
        }catch(Exception e){
            throw new SAXException(e.getMessage());
		}
		String sql = "insert into "+table+" (id,type,name,value,parent,pos) values("+id+","+PI_TYPE+",'"+target+"','"+data+"',0,"+pos+")";
        try{
            do_query(sql,"PIHandler");
        }catch (Exception e){
            throw new SAXException(e.getMessage());
        }
        level.set_int(id,node_level);
        node_level--;
    }
    
    public void startCDATA() throws org.xml.sax.SAXException {
    }
    
    public void endCDATA() throws org.xml.sax.SAXException {
    }
    
    public void startEntity(String name)
    throws SAXException {
    }
    
    public void endEntity(String name)
    throws SAXException {
    }
    
    public void startDTD(String name, String publicId, String systemId)
    throws SAXException {
    }
    
    public void endDTD() throws org.xml.sax.SAXException {
    }
    //===========================================================
    // Utility Methods ...
    //===========================================================
    public void save_attrib_sub(int parent,String attrib_name,String attrib_value) throws Exception{
        if((parent<0)||(parent>id_num)){
            die("<br>G[II<br>save_attrib_sub:em[hԍُłBparent="+parent);
        }
        //@new id̍쐬
        int id = id_num+1;
        id_num++;
        int pos = 1;
        if(parent_buff2.get_int(node_level) == parent){
            pos = index2.get_int(node_level) + 1;
        }else{
            parent_buff2.set_int(node_level,parent);
        }
        index2.set_int(node_level,pos);
		attrib_name = UnicodeToEuc(attrib_name);
		attrib_value = UnicodeToEuc(attrib_value);
        attrib_name = addslashes(attrib_name);
        attrib_value = addslashes(attrib_value);
		attrib_name = xml64.text_encode(attrib_name,enc);
		attrib_value = xml64.text_encode(attrib_value,enc);
        String sql = "insert into "+table+" (id,type,name,value,parent,pos) values("+id+","+ATTR_TYPE+",'"+attrib_name+"','"+attrib_value+"',"+parent+","+pos+")";
        try{
            do_query(sql,"save_attrib_sub");
        }catch (Exception e){
            die(e.getMessage());
        }
	//l[Xy[X̏
        pos = attrib_name.indexOf("xmlns:");
        if(pos != -1){
            attrib_name = replace("xmlns:","",attrib_name);
            id = id_num+1;
            id_num++;
            sql = "insert into "+table+" (id,type,name,value,parent,pos) values("+id+","+NAME_TYPE+",'"+attrib_name+"','"+attrib_value+"',"+parent+",0)";
            try{
                do_query(sql,"save_attrib_sub");
            }catch (Exception e){
                die(e.getMessage());
            }
        }
        pos = attrib_name.indexOf("xmlns");
        if(pos != -1){
            id = id_num+1;
            id_num++;
            sql = "insert into "+table+" (id,type,name,value,parent,pos) values("+id+","+NAME_TYPE+",'default','"+attrib_value+"',"+parent+","+nsd_index+")";
            try{
                do_query(sql,"save_attrib_sub");
            }catch (Exception e){
                die(e.getMessage());
            }
            nsd_index++;
		}
    }
    
    public void save_attrib(int parent,Attributes attribs) throws Exception{
        int num = attribs.getLength();
        for(int i=0;i<num;i++){
            String name = attribs.getQName(i);
            String value = attribs.getValue(i);
            save_attrib_sub(parent,name,value);
        }
    }
    
    public int save_node_sub(int parent,String node_name,Attributes attribs,String NS) throws Exception{
        if((parent<0)||(parent>id_num)){
            die("<br>G[II<br>save_node_sub:em[hԍُłBparent="+parent);
        }
        //System.out.print("save node sub:"+node_name+"\n");
        //@new id̍쐬
        int id = id_num+1;
        id_num++;
        
        int pos=1;
        //@level̍쐬
        node_level = level.get_int(parent) + 1;
        //System.out.print("node_level="+node_level+" parent="+parent+"\n");
        //@eꍇ
        if(parent_buff.get_int(node_level) == parent){
            //@pos̎擾
            pos = index.get_int(node_level) + 1;
        }else{
            //@̃x̐eɎ̐eZbg
            parent_buff.set_int(node_level,parent);
        }
        //@index̃xindexɃZbg
        index.set_int(node_level,pos);
        
        node_name = addslashes(node_name);
        NS = addslashes(NS);
		node_name = xml64.text_encode(node_name,enc);
		NS = xml64.text_encode(NS,enc);
        String sql = "insert into "+table+" (id,type,name,parent,pos,ns) values("+id+","+ELEMENT_TYPE+",'"+node_name+"',"+parent+","+pos+",'"+NS+"')";
        try{
            do_query(sql,"save_node_sub");
        }catch (Exception e){
            die(e.getMessage());
        }
        //System.out.print("save level node_level="+node_level+" id="+id+"\n");
        level.set_int(id,node_level);
        
        save_attrib(id,attribs);
        
        return id;
    }
    
    public int save_textnode_sub(int parent,String text) throws Exception{
        if((parent<0)||(parent>id_num)){
            die("<br>G[II<br>save_textnode_sub:em[hԍُłBparent="+parent);
        }
        //System.out.print("save text sub:"+text+"\n");
        //@new id̍쐬
        int id = id_num+1;
        id_num++;
        
        int pos=1;
        //@level̍쐬
        node_level = level.get_int(parent) + 1;
        //System.out.print("node_level="+node_level+" parent="+parent+"\n");
        //@eꍇ
        if(parent_buff.get_int(node_level) == parent){
            pos = index.get_int(node_level)+1;
        }else{
            parent_buff.set_int(node_level,parent);
        }
        index.set_int(node_level,pos);
        
        text = addslashes(text);
		text = xml64.text_encode(text,enc);
        String sql = "insert into "+table+" (id,type,value,parent,pos) values("+id+","+TEXT_TYPE+",'"+text+"',"+parent+","+pos+")";
        try{
            do_query(sql,"save_textnode_sub");
        }catch (Exception e){
            die(e.getMessage());
        }
        //System.out.print("save level node_level="+node_level+" id="+id+"\n");
        level.set_int(id,node_level);
        node_level--;
        //System.out.print("node_level="+node_level+"\n");
        
        return id;
    }
    public int save_textnode_sub2(int parent,String text) throws Exception{
        if((parent<0)||(parent>id_num)){
            die("<br>G[II<br>save_textnode_sub:em[hԍُłBparent="+parent);
        }
	String sql = "select value from "+table+" where id="+parent+" for update";
        ResultSet rs = do_query(sql,"save_textnode_sub2");
	if(rs.next()){
            String value = rs.getString(1);
            if(value != null){
                value = value.trim();
                if(!value.equals("")){
		 			value = xml64.text_decode(value,enc);
					text = value + "\n" + text;
                }
            }
	}

	text = addslashes(text);
	text = xml64.text_encode(text,enc);
	sql = "update "+table+" set value='"+text+"' where id="+parent;
        try{
            do_query(sql,"save_textnode_sub2");
        }catch (Exception e){
            die(e.getMessage());
        }
        return parent;
    }
    
    public void save_comment(int parent,String comment) throws Exception{
        if((parent<0)||(parent>id_num)){
            die("<br>G[II<br>save_comment:em[hԍُłBparent="+parent);
        }
        //@new id̍쐬
        int id = id_num+1;
        id_num++;
        
        int pos=1;
        node_level = level.get_int(parent) + 1;
        //@eꍇ
        if(parent_buff.get_int(node_level) == parent){
            pos = index.get_int(node_level) + 1;
        }else{
            //@̃x̐eɎ̐eZbg
            parent_buff.set_int(node_level,parent);
        }
        //@index̃xindexɃZbg
        index.set_int(node_level,pos);
        
        comment = addslashes(comment);
		comment = xml64.text_encode(comment,enc);
        String sql = "insert into "+table+" (id,type,value,parent,pos) values("+id+","+COMMENT_TYPE+",'"+comment+"',"+parent+","+pos+")";
        try{
            do_query(sql,"save_comment");
        }catch (Exception e){
            die(e.getMessage());
        }
        
        level.set_int(id,node_level);
        
        node_level--;
    }
    
    public int save_textnode(int parent,String text) throws Exception{
		int id=0;
        if((parent<0)||(parent>id_num)){
            die("<br>G[II<br>save_textnode:m[hԍُłBid="+parent);
        }
        if(press_flg == 1){
			id = save_textnode_sub2(parent,text);
		}else{
			id = save_textnode_sub(parent,text);
		}
        return id;
    }
    
    public int save_node(int parent,String node_name,Attributes attribs,String NS) throws Exception{
        int id;
        if(root_flg == 0){
            id = save_node_sub(0,node_name,attribs,NS);
            root_flg = 1;
        }else{
            if((parent<1)||(parent>id_num)){
                die("<br>G[II<br>save_node:m[hԍُłBid="+parent);
            }
            id = save_node_sub(parent,node_name,attribs,NS);
        }
        return id;
    }
    public String replace(String pat,String chg,String text){
        int begin = 0;
        int pos = text.indexOf(pat);
        int len = pat.length();
        String sub = "";
        while(pos != -1){
            String sub2 = text.substring(begin,pos);
            sub = sub + sub2 + chg;
            begin = pos + len;
            pos = text.indexOf(pat,begin);
        }
        sub = sub + text.substring(begin);
        return sub;
    }
    public String addslashes(String text){
        text = replace("\\","\\\\",text);
        text = replace("\'","\\\'",text);
        text = replace("\"","\\\"",text);
        return text;
    }
    public String stripslashes(String text){
        text = replace("\\\"","\"",text);
        text = replace("\\\'","\'",text);
        text = replace("\\\\","\\",text);
       return text;
    }
    public void die(String text) throws Exception{
        throw new Exception(text);
    }
	public static String UnicodeToEuc(String str) {
    	StringBuffer result = new StringBuffer();
    	char c;
    	for (int i = 0; i < str.length(); i++) {
    	    c = str.charAt(i);
    	    switch (c) {
    	    case 0x2015:
    	        c = 0x2014;
    	        break;
    	    case 0x2225:
    	        c = 0x2016;
    	        break;
    	    case 0xff0d:
    	        c = 0x2212;
    	        break;
    	    case 0xffe0:
    	        c = 0x00a2;
    	        break;
    	    case 0xffe1:
    	        c = 0x00a3;
    	        break;
    	    case 0xffe2:
    	        c = 0x00ac;
    	        break;
    	    case 0xffe4:
        	    c = 0x00a6;
        	    break;
        	}
        	result.append(c);
    	}
    	return result.toString();
	}
	public void uwrite(String str) throws Exception{
        fw.write(str,0,str.length());
	}
	public void get_encode(String xml)throws Exception{
		xml = stripslashes(xml);
		int pos = xml.indexOf("encoding");
		if(pos == -1){
			enc = "ISO-8859-1";
		}else{
			enc = xml.substring(pos+10);
			enc = enc.replaceAll("\'","\"");
			pos = enc.indexOf("\"");
			enc = enc.substring(0,pos);
			if(enc.toUpperCase().equals("SHIFT_JIS")){
				enc = "SJIS";
			}
		}
	}
}